#include <math.h>
#include "Complesso.h"
#include <iostream>

using namespace std;

// Costruttore senza parametri
Complesso::Complesso(){
    re = new float(0);
    im = new float(0);
}

Complesso::Complesso(float r, float i){
    re = new float(r);
    im = new float(i);
}

// Costruttore con un parametro (parte immaginaria sarà inizializzata a zero
Complesso::Complesso(float r){
    re = new float(r);
    im = new float(0);
}
	// Distruttore
Complesso::~Complesso(){
    delete re;
    delete im;
}
	// Costruttore di copia
Complesso::Complesso(const Complesso &x){
    re = new float(*x.re);
    im = new float(*x.im);    
}
	// Operatore di somma
Complesso Complesso::operator+(Complesso x){
    Complesso temp;
    *temp.re = *re + *x.re;
    *temp.im = *re + *x.im;
    return temp;
}
	// Operatore di assegnazione
Complesso Complesso::operator=(Complesso x){
    *re = *x.re;
    *im = *x.im;
    return *this;
}
	// Operatore di assegnazione solo per la parte reale
Complesso Complesso::operator=(float x){
    *re = x;
    *im = 0;
    return *this;
}

                // Calcola il modulo
float Complesso::modulo(){
    return sqrt(*re * *re + *im * *im);
}
        // Calcola la fase
float Complesso::fase(){
    return atan(*im / *re);

}


void Complesso::setReale(float r){
    *re = r;
}

void Complesso::setImmaginario(float i){
    *im = i;
}

void Complesso::stampa(){
    cout << "Re: " << *re << ", Im: " << *im << endl;
}

void Complesso::inserisci(){
    cin >> *re >> *im;
}
